#include <stdio.h>
#include <stdarg.h>

#include "dict_hw.h"
#include "normxcorr_hw_msg.h"

static void reportErrorDefault(const char *msg, ...) {
    char res[1024];
    
    va_list ap;
    
    va_start(ap, msg);
    vsnprintf(res, 1024, msg, ap);
    va_end(ap);
    
    printf("%s\n", res);
}

static void reportMessageDefault(const char *msg, ...) {
    char res[1024];

    va_list ap;
    
    va_start(ap, msg);
    vsnprintf(res, 1024, msg, ap);
    va_end(ap);
    
    printf("%s\n", res);
}

void (*reportError)(const char *msg, ...) = reportErrorDefault;
void (*reportMessage)(const char *msg, ...) = reportMessageDefault;

int reportSet(DICTLogger error_reporter, DICTLogger message_writer) {
    reportError = error_reporter;
    reportMessage = message_writer;

    return 0;
}
